(function() {

	var listbox_items = [];
	var listbox_items_triggers = [];

	if (nnr_of_data != '[]') {

		nnr_of_data = jQuery.parseJSON(nnr_of_data);

		for (var key in nnr_of_data) {
			if (nnr_of_data.hasOwnProperty(key)) {
				listbox_items.push({text: nnr_of_data[key].name, value: nnr_of_data[key].id});
			}
		}

	    tinymce.create('tinymce.plugins.NNRobotsOptinFire', {
	        /**
	         * Initializes the plugin, this will be executed after the plugin has been created.
	         * This call is done before the editor instance has finished it's initialization so use the onInit event
	         * of the editor instance to intercept that event.
	         *
	         * @param {tinymce.Editor} ed Editor instance that the plugin is initialized in.
	         * @param {string} url Absolute URL to where the plugin is located.
	         */
	        init : function(ed, url) {

				ed.addButton('nnr_optin_fire', {
					label: 'Select: ',
					type: 'listbox',
	                title : 'Optin Fire',
	                fixedWidth: true,
	                icon: 'wpsite-gallery',
	                image: url + '/logo.png',
	                onselect: function(e) {
	                    tinymce.execCommand('mceInsertRawHTML', false, '[nnr_optin_fire id="' + this.value() + '"]');
	                },
	                onPostRender: function() {
				        //ed.my_control = this; // ui control element
				    },
					values: listbox_items
	            });
	        },

	        /**
	         * Returns information about the plugin as a name/value array.
	         * The current keys are longname, author, authorurl, infourl and version.
	         *
	         * @return {Object} Name/value array containing information about the plugin.
	         */
	        getInfo : function() {
	            return {
	                longname : '99 Robots',
	                author : '99robots.com',
	                authorurl : 'http://99robots.com',
	                version : "1.0"
	            };
	        }
	    });

	    // Register plugin
	    tinymce.PluginManager.add( 'nnr_optin_fire', tinymce.plugins.NNRobotsOptinFire );
    }

    nnr_of_data_trigger = jQuery.parseJSON(nnr_of_data_trigger);

	for (var key in nnr_of_data_trigger) {
		if (nnr_of_data_trigger.hasOwnProperty(key)) {
			listbox_items_triggers.push({text: nnr_of_data_trigger[key].name, value: nnr_of_data_trigger[key].id});
		}
	}

	/* Register the buttons */
	tinymce.create('tinymce.plugins.OptinFireTrigger', {
          init : function(ed, url) {
               /**
               * Adds HTML tag to selected content
               */
               ed.addButton( 'nnr_optin_fire_trigger', {
	               	label: 'Select: ',
					type: 'listbox',
                    title : 'Optin Fire Trigger',
                    image : url + '/logo.png',
                    cmd: 'nnr_optin_fire_trigger_cmd',
                    onselect: function(e) {
	                    var selected_text = ed.selection.getContent();
						var return_text = '';
						return_text = '<span class="' + nnr_of_data_prefix + 'custom-button ' + nnr_of_data_prefix + 'custom-button-' + this.value() + '">' + selected_text + '</span>';
						tinymce.execCommand('mceInsertContent', 0, return_text);
	                },
                    onPostRender: function() {
				        //ed.my_control = this; // ui control element
				    },
					values: listbox_items_triggers
               });
          },
          createControl : function(n, cm) {
               return null;
          },
     });
     /* Start the buttons */
     tinymce.PluginManager.add( 'nnr_optin_fire_trigger', tinymce.plugins.OptinFireTrigger );
})();