<?php

// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ) exit;

/*
 * This file is used to generate the ouput for the shortcode
 */

add_shortcode('nnr_optin_fire', 'nnr_optin_fire_shortcode');

/**
 * Generate the code for the shortcode
 *
 * @access public
 * @param mixed $atts
 * @return void
 */
function nnr_optin_fire_shortcode($atts) {

	// Check if this post is being displayed in a loop.

	if ( !is_singular() ) {
		return null;
	}

	$args = shortcode_atts( array(
        'id' 						=> null,
    ), $atts );

    global $wpdb;

	// Get all Optins

	$optin_fire = $wpdb->get_results(
		$wpdb->prepare("SELECT * FROM `" . NNRobots_Optin_Fire_DB::getTableName() . "` WHERE `id` = %d", $args['id'])
	, 'ARRAY_A');

	if ( isset($optin_fire[0]) ) {

		$optin_fire = $optin_fire[0];

		// Check that conditions are true

		if (NNRobots_Optin_Fire_Functions::check_conditions($optin_fire, $template, $args, $trigger)) {
			return NNRobots_Optin_Fire_Functions::generate_code($optin_fire, $news_letter);
		}
	}

	return null;

}